//+------------------------------------------------------------------+
//|                                                  Ultra trend.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern int    BarsToCount = 1000;
extern int    Length      = 3;
extern int    Progression = 8;
extern int    Sensitivity = 30;
extern int    Smooth      = 5;
extern bool   Interpolate = true;

//
//
//
//
//

double buffer1[];
double buffer2[];
bool   Calculating;
bool   ReturningBars;
string indicatorFileName;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
      Calculating       = (TimeFrame=="calculate");   if (Calculating) return(0);
      ReturningBars     = (TimeFrame=="returnBars");  if (ReturningBars) return(0);
      indicatorFileName = WindowExpertName();

      //
      //
      //
      //
      //
      
      SetIndexBuffer(1,buffer2);
      timeFrame = stringToTimeFrame(TimeFrame);
      IndicatorShortName("ultra trend "+timeFrameToString(timeFrame)+" ("+Length+","+Progression+","+Sensitivity+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int endLength    = Length + Progression * Sensitivity;            
   int counted_bars = IndicatorCounted();
   int i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
            limit = MathMin(Bars-counted_bars,Bars-1);
            if (ReturningBars)  { buffer1[0] = limit; return(0); }

   //
   //
   //
   //
   //
   
      if (Calculating)
      {
         for (i=limit; i>=0; i--) buffer1[i] = iSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i),Length,i,0);
         return(0);
      }         

   //
   //
   //
   //
   //

   if (BarsToCount==0)
         limit = MathMin(Bars-counted_bars,Bars-1);
   else  limit = MathMin(MathMax(BarsToCount-counted_bars,1),BarsToCount-1);
   if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //
   
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         double valueUp=0;
         double valueDn=0;
         
            for (int k = Length; k <= endLength; k += Progression)
               if (iCustom(NULL,timeFrame,indicatorFileName,"calculate",BarsToCount,k,0,y) > iCustom(NULL,timeFrame,indicatorFileName,"calculate",BarsToCount,k,0,y+1))
                    valueUp++;
               else valueDn++;
               
         buffer1[i] = iSmooth(valueUp,Smooth,i,0);
         buffer2[i] = iSmooth(valueDn,Smooth,i,1);
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSmooth[][10];
double iSmooth(double price,int length, int r, int instanceNo=0)
{
   if (ArrayRange(workSmooth,0)!=Bars) ArrayResize(workSmooth,Bars); instanceNo *= 5; r = Bars-r-1;
 	if(r<=2) { workSmooth[r][instanceNo] = price; workSmooth[r][instanceNo+2] = price; workSmooth[r][instanceNo+4] = price; return(price); }
   
   //
   //
   //
   //
   //

	double alpha = 0.45*(length-1.0)/(0.45*(length-1.0)+2.0);
   	  workSmooth[r][instanceNo+0] =  price+alpha*(workSmooth[r-1][instanceNo]-price);
	     workSmooth[r][instanceNo+1] = (price - workSmooth[r][instanceNo])*(1-alpha)+alpha*workSmooth[r-1][instanceNo+1];
	     workSmooth[r][instanceNo+2] =  workSmooth[r][instanceNo+0] + workSmooth[r][instanceNo+1];
	     workSmooth[r][instanceNo+3] = (workSmooth[r][instanceNo+2] - workSmooth[r-1][instanceNo+4])*MathPow(1.0-alpha,2) + MathPow(alpha,2)*workSmooth[r-1][instanceNo+3];
	     workSmooth[r][instanceNo+4] =  workSmooth[r][instanceNo+3] + workSmooth[r-1][instanceNo+4]; 
   return(workSmooth[r][instanceNo+4]);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}